WiseStampUtils.log("[WiseStampEditor] >>>>>");
WiseStampUtils.catchGlobalExceptions();
WiseStampQuery = $;
WiseStampContext = 'editor';

var WiseStampEditor = new function()
{
	var mCurrentId = null;
	
	this.PREVIEW_DLG_WIDTH = "100%";
	this.PREVIEW_DLG_HEIGHT = 603;
	this.alwaysOpenWizard = false;	//if set to true, wizard will autoopen when editor starts
	
	this.mMappingsModified = false; // TODO: move to controller
	
	this.mTwitterConnectCallback;
	this.mFirstTimeEditor = false;
	this.mSocialTab = new WiseStampServicesTab('WiseStampEditor.mSocialTab','div#tabs-social',WiseStampSignature.socialServices,'social');
	this.mImTab = new WiseStampServicesTab('WiseStampEditor.mImTab','div#tabs-im',WiseStampSignature.imServices,'im');
	this.mBeforeunload = function(){return WiseStampEditor.onCancel(true);};
	
	this.mConduitMsgClients = {};
	
	/////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////
	this.setTwitterConnectCallback = function(callback) {
		this.mTwitterConnectCallback = callback;
	};
	
	/*this.twitterVerify = function() {
		var thisObj = this;
		var cb = new Codebird;
		cb.setConsumerKey('oqn7oY0yXwQttzJDmFZOfQ', 'DNcHjPJRLFWzaPv8cmxAzfF1ZlLwgrokTESSBjI1jeA');
		WiseStampController.getStorage().loadParam("oauth_token", function(oauth_token) {
			WiseStampController.getStorage().loadParam("oauth_token_secret", function(oauth_token_secret) {
				WiseStampController.getStorage().loadParam("oauth_verifier", function(oauth_verifier) {
					cb.setToken(oauth_token, oauth_token_secret);
					cb.__call(
							'oauth_accessToken',
							{oauth_verifier: oauth_verifier},
					function(reply) {
						WiseStampUser.twitterAccessToken(reply.oauth_token);
						WiseStampUser.twitterSecretToken(reply.oauth_token_secret);
						WiseStampUser.storeTwitterCredentials();
						if (typeof WiseStampEditor.mTwitterConnectCallback != 'undefined') {
							thisObj.mTwitterConnectCallback(true, reply.screen_name);
						}
					});
				});
			});
		});
	}*/
	
	this.init = function()
	{
		WiseStampUtils.log("[WiseStampEditor::init] >>>>>");
		var thisObj = this;
	
		$('body').css({width:WiseStamp.window.width});
		$("#tabs").tabs();
		$("#tabs-settings").tabs();	
		
		$('body').addClass(WiseStamp.sys.platform);
		
		$('body:not(#tinymce) a[target="_blank"]').live('click', function(event) {
				WiseStampEditor.openLink($(this).attr("href"));
				event.preventDefault();
			});
			
			var objects = document.getElementsByTagName('*'), i;
			for(i = 0; i < objects.length; i++) {
				if (objects[i].dataset && objects[i].dataset.locale_message) {
					if (objects[i].nodeName == "INPUT") {
						objects[i].value = WiseStampLocale.getLocalizedMessage(objects[i].dataset.locale_message);
					}	else {
						objects[i].innerHTML = WiseStampLocale.getLocalizedMessage(objects[i].dataset.locale_message);
					}
				}
			}
			
		/*WiseStampNotifications.getNotifications(function(notifications){
				for (var n in notifications)
					notifications[n]['description'] = '';
				
				alert(JSON.stringify(notifications[0]));
			});*/
		
		switch (WiseStamp.sys.platform)
		{
			case 'chrome':
				if (typeof chrome.extension == 'undefined')
					break;
				
				chrome.extension.onRequest.addListener(
					function onRequest(request,sender,sendResponse)
					{
						switch (request.command)
						{
							case "focusEditor":
								if (typeof request.query != "undefined")
									thisObj.handleQueryParams(request.query);
								
								if(typeof request.query == 'undefined' || (typeof request.query != 'undefined' && request.query.type != "silent"))
									alert(WiseStampLocale.getLocalizedMessage("editor_hiding"));
								
								//localStorage["type"] = "";
								WiseStampController.getStorage().saveParam("type", "");
								
								if(typeof request.query != 'undefined' && request.query.isTwitter == true) {
									if(request.query.success) {
										WiseStampEditor.twitterVerify();
										//cb.setToken(localStorage["oauth_token"], localStorage["oauth_token_secret"]);
									}
									else {
										if(typeof WiseStampEditor.mTwitterConnectCallback != 'undefined') {
											WiseStampEditor.mTwitterConnectCallback(false);
										}
									}
								}
								
								//this.window.focus();
								//this.document.body.focus();
								break;
						}
					});
					
				window.addEventListener("beforeunload", this.mBeforeunload, false);
				break;
				
			case 'mozilla':
				document.__defineGetter__(
						"domain",
						function() {return 'www.whateveriwant.com'}
					);
					
				window.addEventListener("callTwitterConnectCallback", 
					function(){
						WiseStampUser.loadTwitterCredentials();
						thisObj.mTwitterConnectCallback(true, WiseStampUser.twitterScreenName());
					},
					false);
				
				window.addEventListener("WisestampCloseEditor",WiseStampEditor.onCancel,true);
				
				break;
			
			case 'safari':
				window.addEventListener("beforeunload", this.mBeforeunload, false);
				break;
		}
		
		$('#tabs #apps').show();
		WiseStampAppsView.init($('#tabs-apps'));
				
		//WiseStampHtmlEditor.init('textarea'); // for nicEdit should be placed here
		WiseStampController.init(
			function()
			{
				WiseStampAB.init();
				WiseStampExtension.init();
				
				WiseStampAppsView.refreshGallery();
				initSignaturesSelector();
				WiseStampEditor.onDataUpdated();
				
				WiseStampHtmlEditor.init('textarea', WiseStampEditor.adjustHeightAndWidth);
				
				if (WiseStamp.config.debug)
				{
					$('.menu').append(' | ');
					$('.menu').append($('<a id="unittest">Test</a>').click(function(){WiseStampEditor.unitTest();}));
					
					$('.menu').append(' | ');
					$('.menu').append($('<a id="reload">Reload</a>').click(function(){WiseStampEditor.reload();}));
					
					$('.menu').append(' | ');
					$('.menu').append($('<a id="firebug">Firebug</a>').click(function(){WiseStampEditor.openFirebug()}));
				}
				
				if (WiseStamp.config.support.premium)
					$('.premiumElement').removeClass('premiumElement');
			
				WiseStampEditor.onInitComplete();
				updateUserStatus();
			});
		
		var updateDetails = WiseStampExtension.getUpdateDetails();
		if (updateDetails != "{}") {
			var json = WiseStampUtils.jsonParse(updateDetails);
			
			if (typeof json == "object" && json != null && typeof json.URL == "string") {
				var link = $("#updateWiseStamp");
				link.click(function() {
						WiseStampUtils.openWindow(json.URL);
					});
				
				link.show();
			}
		}

		// jquery-ui button, highlight on hover
		$('button.ui-state-default').hover(function(){$(this).addClass('ui-state-hover')},function(){$(this).removeClass('ui-state-hover')});
		
		$('a#signatureExamples').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.signature_examples,true)});
		$('a#settings').click(function(){WiseStampSettingsDlg.show()});
		$('a#help').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.help,true)});
		$('a#home').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.home,true)});
		$('a#helpOnline').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.help,true)});
		
		$('#signatureActions #default').click(function(){return WiseStampSettingsDlg.show("defaults");});
		$('#signatureActions #rename').click(function(){return WiseStampEditor.onRenameSignature();});
		$('#signatureActions #delete').click(function(){return WiseStampEditor.onDeleteSignature();});
		$('#signatureActions #create').click(function(){return WiseStampEditor.onCreateSignature();});
		$('#signatureActions #open_wizard').click(function(){return WiseStampEditor.onOpenWizard();});

		$('#wizard-link').click(function(){return WiseStampWizard.open(WiseStamp.getURL("content/src/wizard/steps/index.htm"));});
		$('#templates-icon').click(function(){return WiseStampEditor.onTemplateSelect();});
		$('#templates-text').click(function(){return WiseStampEditor.onTemplateSelect();});

		$('#add-social a').click(function(){return WiseStampEditor.onAddSocialService();});
		$('#edit-social a').click(function(){return WiseStampEditor.onEditSocialSettings();});
		$('#edit-social-custom a').click(function(){return WiseStampEditor.onEditCustomIcons();});

		$('#add-im a').click(function(){return WiseStampEditor.onAddImService();});
		$('#edit-im a').click(function(){return WiseStampEditor.onEditImSettings();});
		$('#edit-im-custom a').click(function(){return WiseStampEditor.onEditCustomIcons();});

		$('button#submitBug').click(function(){WiseStampEditor.onSubmitBug()});
		
		$('.login-action').click(function(){WiseStampEditor.onLogin()});
		$('.register-action').click(function(){WiseStampEditor.onRegister()});
		$('#manage-subscription').click(function(){WiseStampEditor.onManagePlan();});
		$('#change-password').click(function(){WiseStampSettingsDlg.passwordsDlg();});
		
		$('.usermenu a#logout').click(function(){WiseStampEditor.onLogout()});
		$('.usermenu a#fbconnect').click(function(){WiseStampEditor.onFbLogin()});
		$('.usermenu a#account').click(function(){WiseStampEditor.onAccountSettings()});
		$('.menu a#upgrade').click(function(){WiseStampEditor.onUpgrade('editor','link')});
		
		$('a#shareOnFacebook').click(function(){WiseStampUtils.openWindow(WiseStamp.config.URLs.share_facebook)});
		$('a#shareOnTwitter').click(function(){WiseStampUtils.openWindow(WiseStamp.config.URLs.share_twitter)});
		
		$('#resetSettings').click(function(){WiseStampSettingsDlg.onResetSettings()});
		$('#repair').click(function(){WiseStampUtils.openWindow(WiseStamp.config.URLs.website.repair)});
		
		$('a.tab#social').click(function(){WiseStampEditor.mSocialTab.init(WiseStampController.getData().signatures[mCurrentId].socialServices)});
		$('a.tab#im').click(function(){WiseStampEditor.mImTab.init(WiseStampController.getData().signatures[mCurrentId].imServices)});
		
		$('#addEmailAppsTag').change(function(){return WiseStampSettingsDlg.onEmailTagChange()});
		$('#templatesDialog button.upgrade').click(function(){return WiseStampEditor.onUpgrade('feature','templates')});
		
		$('#colorButtonContainer a').click(function(){return WiseStampEditor.onUpgrade('editor','accountDetails');});

		$('#store-settings').click(function(){return WiseStampSettingsDlg.saveToServer();});
		$('#load-settings').click(function(){return WiseStampSettingsDlg.loadFromServer();});
		
		$('#findUpdateButton').click(function(){return WiseStampSettingsDlg.findUpdate();});
		
		$('#upgrade-from-templates').click(function(){return WiseStampEditor.onUpgrade('editor','templates');});
		$('#upgrade-from-popup').click(function(){return WiseStampEditor.onUpgrade('editor','afterLogin');});

		$('#change-promotion').click(function(){return WiseStampSettingsDlg.changePromo();});
		
		$('#preview-button').click(function(){return WiseStampEditor.showPreview();});
		$('#apply-button').click(function(){return WiseStampEditor.save();});
		$('#ok-button').click(function(){return WiseStampEditor.onOK();});
		$('#cancel-button').click(function(){return WiseStampEditor.onCancel();});
		
		WiseStampUI.initMenu($('.popupMenu#signatures'));
		
		$('.helpMark').each(function(index,obj){
				$(obj).click(function(){WiseStampEditor.openLink($(obj).attr('link'),true)});
				$(obj).hover(
						function(){$(obj).addClass('helpMarkActive')},
						function(){$(obj).removeClass('helpMarkActive')});
			});
			
		//this.footerSocialButtons();	//moved to WiseStampEditor.onUserAvailable(), because we need to know the user for FB stuff
	}
	
	this.onUserAvailable = function()
	{
		WiseStampController.filterMappingsSet();
		
		var thisObj = this;
	
		this.handleQueryParams(undefined,function(){
		
				if (!WiseStamp.config.support.offline && WiseStampUser.loggedIn() == false)
				{
					WiseStampWizard.open("content/src/wizard/steps/index.htm", "first_time", "fullscreen=yes");
					return;
				}
				
				WiseStampNotifications.notified('firstTimeEditor',undefined,
						function(value) {
							if (!WiseStampEditor.alwaysOpenWizard && value == true)	//if alwaysOpenWizard is set to TRUE the wizard will open every time the extension is opened
								return;
							
							if (WiseStamp.config.support.offline == true) {
								WiseStampAB
									.test('First Time Wizard')
									.variant('With Wizard', function(){
											if (WiseStamp.sys.platform == "safari") {
												WiseStampWizard.open("content/src/wizard/steps/index.htm", "first_time", "overlay=solid,height=630");
											}
											else {
												WiseStampWizard.open("content/src/wizard/steps/index.htm", "first_time")//, "fullscreen=yes");
											}
										})
									//.variant('Without Wizard',function(){})
									.go();
							}
							
							WiseStampNotifications.notified('firstTimeEditor',true);
							thisObj.mFirstTimeEditor = true;
						});
				});
			
		this.footerSocialButtons();
	}
	
	this.onInitComplete = function()
	{
		var thisObj = this;
	
		WiseStampAnalytics.trackEvent('editor', 'open');

		this.onUserAvailable();
		
		if (!WiseStampUser.loggedIn() && WiseStampUtils.isEmpty(WiseStampUser.username()))
			this.loginByCookie();
	}
	
	this.adjustHeightAndWidth = function() {
		// Don't resize when the editor is opened without the options.xul wrapper (So we can open it in a tab)
		if (WiseStamp.sys.platform == "mozilla" && typeof window.top != "undefined") {
			if (!/.xul$/.test(window.top.location.href)) {
				return false;
			}
			else {
				if (window.top.location.search == "?noresize")
					return false;
			}
		}
		if (WiseStamp.sys.platform == "safari") // in safari, editor opens in tab
			return false;
		
		var win = window.top // for Mozilla's options.xul
		var UI_height = win.outerHeight - win.innerHeight;
		var body_height = $("#wrap").outerHeight(true);
		
		var UI_width = win.outerWidth - win.innerWidth;
		var body_width = $("#wrap").outerWidth(true);
		
		/* Execute */
		if (WiseStamp.sys.platform == "mozilla") {
			win.resizeTo(body_width + UI_width, body_height + UI_height);
		}
		else {
			win.resizeTo(body_width + UI_width, body_height + UI_height + 15);
		}
	}
	
	this.handleQueryParams = function(query,callback)
	{
		var thisObj = this;
		
		if (typeof query == "undefined") {
			var query = {};
			
			if ('arguments' in window.parent && window.parent.arguments[0])
				query = window.parent.arguments[0];
			else {
				var queryParameters = WiseStampUtils.queryParameters();
				for (var parameter_name in queryParameters)
					query[parameter_name] = queryParameters[parameter_name];
			}
		}
		
		WiseStampInstallMgr.setParams(query);
		
		var queryValue;
		if (query.view) {
			$('#globalLoadingOverlay').remove();

			switch (query.view) {
				case 'login':
					thisObj.onLogin();
					break;

				case 'help':
					thisObj.onHelp();
					break;
			}
			
			queryValue = query.view;
			if (typeof callback != 'undefined')
				callback();
		}
		else if (query.install_app) {
			function add_app() {
				$('#globalLoadingOverlay').remove();

				var params = {};
				var text = 'Congratulations! Your <span data-type="var" data-name="TITLE" data-target=""></span> Email App was successfully added!<br/><br/>\
						(click "Preview" to see the result).<br/><br/>';
				
				switch (query.install_app){  
					case "give2gether":
						params['projectID'] = query.install_app_campaign;
						break;
				}
				
				return WiseStampInstallMgr.addApp(query.install_app, params, callback, true);
			}
		
			if (query.install_custom_app == "true") {
				var domain = 'http://apps.wisestamp.com';
				if ('install_domain' in query)
					domain = query.install_domain;
					var url = domain+'/api/app/get?id='+query.install_app;
					WiseStampInstallMgr.updateCustomApp(query.install_app, url, function(json) {
						WiseStampAppsView.refreshGallery();
						add_app();
						WiseStampAppsView.showCategory(json.meta.categories[0]);
						
						var item = $("#gallery").find("#" + json.meta.id);
						if (item.length > 0) {
							item.eq(0).trigger("click");
							item[0].scrollIntoView(false);
						}
					});
				
				queryValue = "app=" + query.install_app;
			}
			else {
				var result = add_app();
				if (result == true)
					queryValue = "app=" + query.install_app;
			}
		} else {
			$('#globalLoadingOverlay').remove();
			if (typeof callback != 'undefined')
				callback();
		}
		
		WiseStampAnalytics.trackEvent('editor', 'view', queryValue);
	}
	
	this.showFirstTimeTour = function()
	{
		var headElement = document.getElementsByTagName("head")[0];
	    var newScript = document.createElement('script');
	    newScript.type = 'text/javascript';
	    newScript.src = 'firstTimeTour.js';
	    headElement.appendChild(newScript);
	    
	    
	    var newStyle = document.createElement('link');
	    newStyle.type = 'text/css';
	    newStyle.rel = 'stylesheet';
	    newStyle.href = '../css/tour.css';
	    headElement.appendChild(newStyle);
	}
	
	this.unitTest = function()
	{
		this.openLink(WiseStampUtils.getUrl("Selenium/core/TestRunner.html"));
		
		/*var headElement = document.getElementsByTagName("head")[0];
	    var newScript = document.createElement('script');
	    newScript.type = 'text/javascript';
	    newScript.src = 'unittest.js';
	    headElement.appendChild(newScript);*/
	}

	/*this.reload = function()
	{
		var scripts = [];
		var i = 0;
		var oldScripts = document.getElementsByTagName('script');
		while (i < oldScripts.length)
		{
			if (document.scripts[i].src != "") 
			{
				var src = document.scripts[i].src;
				src += (src.indexOf('?') == -1) ? '?' : '&';
				src += "r=" + Math.random();
				
				scripts.push(src);
				
				oldScripts[i].parentNode.removeChild(oldScripts[i])
				continue;
			}
			
			i++;
		}
		
		for (var iNewScript = 0; iNewScript < scripts.length; iNewScript++)
		{
			var headElement = document.getElementsByTagName("head")[0];
			var newScript = document.createElement('script');
			newScript.type = 'text/javascript';
			newScript.src = scripts[iNewScript];
			headElement.appendChild(newScript);
			
			//alert(scripts[iNewScript]);
		}
	}*/

	/*this.openFirebug = function()
	{
		var headElement = document.getElementsByTagName("head")[0];
		var newScript = document.createElement('script');
		newScript.type = 'text/javascript';
		newScript.src = "http://fbug.googlecode.com/svn/lite/branches/firebug1.4/content/firebug-lite-dev.js#startOpened=true";
		headElement.appendChild(newScript);
	}*/
	
	/////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////

	function resetSignatureSelect()
	{
		$('select#signatureSelect option').removeAttr('selected');
		$('select#signatureSelect option#'+mCurrentId).attr('selected','selected');
	}
	
	function onSignatureSelect(element)
	{
		var id = element.attr('id');
		if (id == mCurrentId || id == '')
		{
			resetSignatureSelect();
			return;
		}
		
		WiseStampEditor.saveCurrentSignature();
		WiseStampEditor.setCurrentSignature(id);
	}
	
	function initSignaturesSelector() 
	{
		var signatures = WiseStampController.getSignaturesList();
		var defaultId = WiseStampController.defaultSigId();
		var selectElement = $('#signatureSelect');

		// add signature creation option
		var addTitle = $('#signatureActions #create').text();
		selectElement.append('<option style="color: #ddd;" disabled="true">——————————————————</option>');
		selectElement.append('<option id="create" class="action">'+addTitle+'</option>');
		
		selectElement.change(function() {
				var selectedElement = $(this).find('option:selected');
				if (selectedElement.attr('id') == 'create')
				{
					resetSignatureSelect();
					WiseStampEditor.onCreateSignature();
					return;
				}
				
				onSignatureSelect(selectedElement);
			});
	}
	
	function clear()
	{
		WiseStampEditor.mSocialTab.clear();
		WiseStampEditor.mImTab.clear();
		WiseStampHtmlEditor.clear();
		WiseStampAppsView.clear();
	}
	
	this.saveCurrentSignature = function()
	{
		var signature = WiseStampController.getData().signatures[mCurrentId];
		
		if (typeof signature == 'undefined')
			return;
		
		signature.title = $('select#signatureSelect option#'+mCurrentId).html();
		
		signature.editorhtml = WiseStampHtmlEditor.getContent();
		signature.html = WiseStampTemplateMgr.removeDataAttrs(signature.editorhtml);
		
		if (WiseStampEditor.mSocialTab.initialized())
			signature.socialServices = WiseStampEditor.mSocialTab.getServices();
		
		if (WiseStampEditor.mImTab.initialized())
			signature.imServices = WiseStampEditor.mImTab.getServices();
		
		// check if needed - also saved in the controller
		//signature.apps = WiseStampController.getAppsMgr(mCurrentId).getAppsParams();
		
		signature.borderType = $('#borderType option:selected').attr('id');
		signature.bgColor = $('#bgColor option:selected').attr('id');
	}
	
	function sendDataUpdate()
	{
		WiseStampUtils.log('[WiseStampEditor::sendDataUpdate] >>>>>');
		switch(WiseStamp.sys.platform)
		{
		case 'chrome':
			var request = {command: 'updateData'};
			chrome.extension.sendRequest(request, function(response) {});
			break;
			
		case 'safari':
			var request = {command: 'updateData'};
			safari.self.tab.dispatchMessage('request',request);
			break;
			
		case 'mozilla':
			var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
			var enumerator = ww.getWindowEnumerator();
			while (enumerator.hasMoreElements()) 
			{
				var targetWin = enumerator.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
				if (targetWin.location != 'chrome://browser/content/browser.xul' && targetWin.location != 'chrome://messenger/content/messenger.xul')
					continue;
				
				var doc = targetWin.document;
				var evt = doc.createEvent("Events");
				evt.initEvent("WisestampUpdateData", true, false);
				var canceled = !targetWin.dispatchEvent(evt);
			}

			break;
			
		case 'web':
		case 'conduit':
			SendMessage('wisestampDataUpdated','{}');
			break;
		}
	}
	
	this.sendDataUpdate = sendDataUpdate;	//for external usage (by controller)
	
	this.save = function(callback)
	{
		WiseStampAnalytics.trackEvent('editor','save');
		
		$("div#alert").html("<img src='../img/loading.gif' style='vertical-align: bottom;'/>" + WiseStampLocale.getLocalizedMessage("editor_saving"));		
		$("div#alert").attr('title','WiseStamp');		
		$("div#alert").dialog({ bgiframe: false, modal: true, buttons: {}, zIndex: 5000});
		$("div#alert").dialog('open');
		
		this.saveCurrentSignature();
		
		if (this.mMappingsModified)
		{
			WiseStampController.saveMappings();
			this.mMappingsModified = false;
		}
		
		WiseStampController.save(
			function(){
				$("div#alert").dialog('close');
				
				sendDataUpdate();
				
				if (typeof callback != 'undefined')
					callback();
				});
	}
	
	function updateButtons()
	{
	}
	
	function refreshServicesTab(clear)
	{
		if (clear == true)
		{
			WiseStampEditor.mSocialTab.clear();
			WiseStampEditor.mImTab.clear();
		}
		
		var currentTabId = $("#tabs").find('.ui-state-active a').attr('id');
		switch (currentTabId)
		{
			case 'social':
				WiseStampEditor.mSocialTab.init(WiseStampController.getData().signatures[mCurrentId].socialServices);
				break;
			case 'im':
				WiseStampEditor.mImTab.init(WiseStampController.getData().signatures[mCurrentId].imServices);
				break;
		}
	}
	
	this.getCurrentSignature = function()
	{
		return mCurrentId;
	}

	this.setCurrentSignature = function(id)
	{
		clear();
		
		//$('a.tab#apps').click();
		
		var signature = WiseStampController.getData().signatures[id];
		
		var html = signature.html;
		if (typeof signature.editorhtml == "string")
			html = signature.editorhtml;
		
		WiseStampHtmlEditor.setContent(html);
		WiseStampAppsView.setCurrentSignature(id);
	
		$('#borderType option#'+signature.borderType).attr('selected','selected');
		$('#bgColor option#'+signature.bgColor).attr('selected','selected');
			
		mCurrentId = id;
		updateButtons();
		
		refreshServicesTab();
	}
	
	function screenshot(callback, isApprovedToLog)
	{
		function logToGoogleDocs(arr) {
			var docUrl = 'https://docs.google.com/spreadsheet/formResponse?hl=en_US&formkey=dDd0eE9wTzctcnBZMXZxMEpqeDVadlE6MQ&ifq';
			var params = { /* These additional parameters are taken from the <form> element in docUrl */
					"pageNumber": "0",
					"backupCache": "",
					"submit": "Submit"
				};
			
			for (var i = 0; i < arr.length; i++) {
				if (typeof arr[i] != "string")
					return false;
				
				params['entry.' + i + '.single'] = arr[i];
			}
			
			$.post(docUrl, params);
		}
		
		function crop_and_send_dataURI(dataURI) {
			var canvas = document.createElement("canvas");

			var ctx = canvas.getContext('2d');
			var img = new Image();
			$(img).load(function() {
				var previewFrame = $("#previewFrame"); // Updates values of offset()
				var wrapper = previewFrame.contents().find("body > div:eq(0)");
				
				var pixels = {
					top: $("#previewFrame").offset().top + wrapper.offset().top,
					left: $("#previewFrame").offset().left + wrapper.offset().left,
					width: wrapper.width(),
					height: Math.max(wrapper.height(), 180)
				}
				if (pixels.height > previewFrame.height())
					pixels.height = previewFrame.height();
				
				// Draw and crop
				canvas.width = pixels.width;
				canvas.height = pixels.height;
				
				ctx.drawImage(img, pixels.left, pixels.top, pixels.width, pixels.height, 0, 0, pixels.width, pixels.height);
				
				$("#post-upload").val(canvas.toDataURL());
				WiseStampUI.startWaiting($('#previewDlg').parent());
				WiseStampUpload.run(
						$("#upload-form"),
						WiseStamp.config.URLs.APIs.upload_preview,
						function(json) {
								WiseStampUI.stopWaiting($('#previewDlg').parent());
								callback(json.url);
								
								if (isApprovedToLog)
									logToGoogleDocs([WiseStampUser.username(), json.url, WiseStampUser.name()]);
							}
					);
			});
			img.src = dataURI;
		}
		
		switch (WiseStamp.sys.platform) {
			case "chrome":
				chrome.tabs.getCurrent(function(tab) {
					chrome.tabs.captureVisibleTab(tab.windowId, {format: "png", quality: 100}, crop_and_send_dataURI);
				});
				
			break;
			
			case "mozilla":
				var canvas = document.createElement("canvas");
				canvas.width = window.innerWidth;
				canvas.height = window.innerHeight;
				
				var ctx = canvas.getContext('2d');
				ctx.drawWindow(window, 0, 0, window.innerWidth, window.innerHeight, "rgb(255,255,255)");
				crop_and_send_dataURI(canvas.toDataURL());
				
			break;
			
			case "safari":
				WiseStampUtils.sendRequest({command: 'screencapture'}, function(dataURI) {
					crop_and_send_dataURI(dataURI);
				});
				
			break;
		}
	}
	
	function share(baseURLs, element)
	{
		if (WiseStampUser.featureSupported('sharePreview') == false)
			return false;
		
		var form = new WiseStampFormDlg();
		form.title("Share your signature");
		form.addRadioGroup('share_dialog_to_website', 'Share on: ', [
				{
					id: "Facebook",
					label: '<img src="' + WiseStampUtils.getUrl('content/icons/facebook.png') + '" /> Facebook'
				},
				{
					id: "Twitter",
					label: '<img src="' + WiseStampUtils.getUrl('content/icons/twitter.png') + '" /> Twitter'
				}
			], "Facebook");
		
		form.addCheckbox('share_dialog_approve', WiseStampLocale.getLocalizedMessage("editor_share_approve"), true);
		
		form.show('share_dialog', 275, undefined, function(values) {
				var isApproved = values["share_dialog_approve"];
				var toWebsite = values["share_dialog_to_website"];
				var baseURL = baseURLs[toWebsite];
				
				window.setTimeout(function(){
						screenshot(function(url) {
								WiseStampAnalytics.trackEvent('editor', 'previewShare', toWebsite, isApproved ? '1' : '0');

								if (typeof url == "undefined") {
									WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_screenshot_problem"));
									return;
								}

								var match = url.match(/https?:\/\/[^\/]+\/(.+)/);
								var path = typeof match[1] == "string" ? match[1] : "";
								WiseStampUtils.openWindow(baseURL + encodeURIComponent(WiseStamp.config.URLs.APIs.preview_page + path));
							}, isApproved);//*/
					},0);
			}, "Share");
		
		$("#share_dialog").parent().find(".ui-dialog-buttonpane button:contains("+WiseStampLocale.getLocalizedMessage('editor_cancel')+")").hide();
	}

	function appendShareSignature(dlg)
	{
		var buttonpane = dlg.parent().find(".ui-dialog-buttonpane");
		buttonpane.css({ position: "relative" });
		buttonpane.append('<div id="share-signature">' + WiseStampLocale.getLocalizedMessage("editor_share_like_question") + '<a id="share-signature-button"><img src="../img/share_it.png" /></a></div>');
		
		$("#share-signature-button").click(function() {
				share({
						"Facebook": WiseStamp.config.URLs.APIs.share_facebook,
						"Twitter": WiseStamp.config.URLs.APIs.share_twitter + "Check out my @WiseStamp signature - &url="
					}, $("#share-signature"));
			});
	}
	
	this.openPreviewDlg = function(html, vertical_html)
	{
		if(html == "" && vertical_html == "") {
			html = "You havn't created a signature yet!";
		}
		var dlg = $('<div id="previewDlg"></div>');
		$('body').append(dlg);
		
		function closePreview() {
			dlg.remove();
			$("#share-signature").remove();
		}
		
		dlg.attr('title','Preview');
		dlg.dialog({
				'modal': true,
				height: this.PREVIEW_DLG_HEIGHT,
				width: this.PREVIEW_DLG_WIDTH,
				buttons: {
					Close: closePreview
				}
			});

		dlg.dialog('open');
		dlg.bind('dialogclose',closePreview);
		
		dlg.html('<iframe type="content" src="" id="previewFrame" frameborder="0" width="100%" height="98%"></iframe>');
                
		if (WiseStamp.sys.platform != 'conduit' && $("share-signature").length == 0)
			appendShareSignature(dlg);
		
		var previewFrame = $('#previewFrame');
		window.setTimeout(function() {
				previewFrame.contents().find('head').append('<link rel="stylesheet" type="text/css" href="../css/preview.css" media="screen" />');
				previewFrame.contents().find('body').append($('.sig_wrapper').clone());
				var wrap = previewFrame.contents().find('body .sig_wrapper .currentSignature');

				if (!WiseStampUtils.isEmpty(vertical_html)) {
					wrap.append(vertical_html);
					wrap.find(".ws-user-content").append("<br><br>");
					wrap.find(".ws-user-content").append(html);
				}
				else
					wrap.append(html);
				
			}, 500);
	}
	
	this.showPreview = function()
	{
		this.saveCurrentSignature();
		
		var self = this;
		WiseStampController.getSignatureHtml(mCurrentId,'preview', function(ret) {
				self.openPreviewDlg(ret.html, ret.vertical_html);
				WiseStampAnalytics.trackEvent('editor','preview');
			});
	}
	
	this.onSubmitBug = function(error)
	{
		function submitBug(form,settingsUrl,callback)
		{
			var params = {};
			if (WiseStampUser.loggedIn() == false)
			{
				params['name'] = form.getTextValue('name');
				params['email'] = form.getTextValue('email');
			
			} else
			{
				params['name'] = WiseStampUser.name();
				params['email'] = WiseStampUser.username();
			}
			
			params['plan'] = WiseStampUser.plan();
			
			params['reproduce'] = form.getTextValue('reproduce');
			params['desc'] = form.getTextValue('description');
			params['screenshot'] = form.getTextValue('screenshot');
			params['error'] = form.getTextValue('error_message');
			
			params['version'] = WiseStampExtension.getVersion();
			params['platform'] = WiseStamp.sys.platform;
			params['browser'] = WiseStampUtils.getBrowserType();
			params['browser_version'] = WiseStampUtils.getBrowserVersion();
			params['os'] = navigator.platform;
			params['settings'] = settingsUrl;

			var paramsPairs = []
			for (param in params)
				paramsPairs.push(param + '=' + encodeURIComponent(params[param]))
			
			var url = WiseStamp.config.URLs.APIs.user + '/support';
			WiseStampUtils.getRemoteData({
			        url: url,
			        type: 'GET',
			        data: paramsPairs.join('&'),
			        success: function(data){
			        		WiseStampUtils.alert(WiseStampLocale.getLocalizedMessage("editor_submit_bug"));
			        		callback(true);
			        	},
			        error: function(XMLHttpRequest, textStatus, errorThrown) {
			        		WiseStampUtils.alert(WiseStampLocale.getLocalizedMessage("editor_internal_error")); 
			        		callback(false);
			        	}
				});
				
			//$.post(docUrl,params);
			
		}
		
		function getPasteUrl(content,password,callback)
		{
			var params = [];
		
			// ampresand screws up the post data - fix it
			params.push('paste='+encodeURI(content).replace(/&/g,"%26"));
			params.push('is_private=1');
			params.push('password='+encodeURI(password));
			
			WiseStampUtils.getRemoteData({
			        url: 'http://tny.cz/api/create.json',
			        type: 'POST',
			        data: params.join('&'),
			        success: function(data) {
			        		var response = null;
			        		try {
			        			response = JSON.parse(data);
			        		} catch (e) 
			        		{
			        			WiseStampUtils.log("[WiseStampEditor::getPasteUrl] failed to get url, exception = " + e);
			        			callback('');
					        	return;
					        }
			        		
			        		if (typeof response.result.error != 'undefined')
			        		{
			        			WiseStampUtils.log("[WiseStampEditor::getPasteUrl] failed to get url, error = " + response.result.error);
					        	callback('');
					        	return;
			        		}
			        		
							var pasteUrl = 'http://tny.cz/'+response.result.response;
							callback(pasteUrl);
			        	},
			        error: function(XMLHttpRequest, textStatus, errorThrown) {
			        		WiseStampUtils.log("[WiseStampEditor::getPasteUrl] failed to get reponse, error = "+textStatus);
					        callback('');
				        }
				});
		}
		
		error = (typeof error == 'undefined') ? '' : ''+error;
		
		var dlgHeight = 455;
		var html = $('<div id="submitBug" />');
		var form = new WiseStampFormDlg();
		if (WiseStampUser.loggedIn() == false)
		{
			dlgHeight += 45;
			form.addTextInput('name','Your name:');
			form.addTextInput('email','Your email (Required):','',true);
		}
		
		form.addTextAreaInput('description','What didn\'t work?',"",true);
		form.addTextAreaInput('reproduce','Help us help you. Describe the last actions you\'ve taken that caused the issue (Optional)',"1.\n2.\n3.\n",false);
		form.addTextInput('screenshot','Screen capture URL<span class="notes"><sup>1</sup></span>:');
		//form.addHtml('&nbsp;');
		form.addCheckbox('senddata','Include my signature settings to help us better understand what happened',true);
		form.addHtml('<div class="notes"><sup>1</sup> We recommend using <a id="goto-jing">Jing</a> for sharing your screen</div>');
		form.addHtml('<textarea id="error_message" class="hidden">' + error + '</textarea>');

		form.dialog().find("#goto-jing").click(function(){WiseStampUtils.openWindow('http://www.jingproject.com');});

		form.async(true);
		form.title("Send us a bug report");
		form.show(
			'submitBug','550px',dlgHeight,
			function(values,callback){
				if (values['senddata'])
				{
					getPasteUrl(WiseStampController.getStorage().toText(),form.getTextValue('email') || WiseStampUser.username(),
							function(pasteUrl) {
								submitBug(form,pasteUrl,callback);
							});
				} else
					submitBug(form,'',callback);
			});
	}
	
	this.onHelp = function()
	{
		function helpClick(element)
		{
			var href = $(element).attr('href');
			WiseStampEditor.openLink(href,true);
			return false;
		}
		
		var dlg = $('#helpDialog');
		
		dlg.attr('title', WiseStampLocale.getLocalizedMessage("editor_help"));
		var buttonObject = {};
		buttonObject[WiseStampLocale.getLocalizedMessage("editor_cancel")] = function(){dlg.dialog('close');};
		dlg.dialog({ bgiframe: true, height:500, width:520, modal: true, buttons: buttonObject});
		dlg.dialog('open');
	
		if (dlg.attr('loaded') == 'true')
			return;
		
		dlg.find('#loading').show();
		
		WiseStampUtils.getRemoteData({
				url: WiseStamp.config.URLs.APIs.help,
		        type: 'GET',
		        data: '',
		        success: function(data){
		        		data = $(data);
		        		data.find('a').each(function(index,obj)
	        				{
	        					$(obj).click(function(){return helpClick(this)});
	        				});
		        		
		        		dlg.find('#loading').hide();
		        		dlg.find('#remote').html(data);
		        		dlg.find('#helpContent').show();
		        		dlg.attr('loaded','true');
		        	},
		        error: function(XMLHttpRequest, textStatus, errorThrown) {
		        		dlg.find('#loading').hide();
	        			WiseStampUtils.alert(WiseStampLocale.getLocalizedMessage("editor_internal_error")); 
		        	}
			});
	}
	
	function sendMessageToScript(type,msg)
	{
		chrome.tabs.getSelected(null, function(tab) {
			chrome.tabs.sendRequest(tab.id, {type: type, value: msg}, function(response) {
				console.log(response.farewell);
			});
		});
	}
	
	this.onCreateSignature = function()
	{
		if (WiseStampController.signaturesCount() >= WiseStampUser.m())
		{
			// todo: change to 'feature'
			var plan = 
				(WiseStampController.signaturesCount() < WiseStampUser.MULTI_SIG_COUNT) ?
				'multi'	: 'multiUnltd';
			
			if (WiseStampUser.featureSupported(plan) == false)
				return;
		}
		
		var form = new WiseStampFormDlg();
		form.addTextInput('name',WiseStampLocale.getLocalizedMessage("editor_signature_name"),'');
		
		form.show(
			'create',
			350,
			undefined,
			function()
			{
				var title = form.getTextValue('name');
				if (title == '')
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_signature_name_enter_valid"));
					return false;
				}
				
				if (WiseStampController.signatureTitleExists(title))
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_signature_name_unique"));
					return false;
				}
				
				WiseStampEditor.saveCurrentSignature();
				
				var id = WiseStampController.createSignature(title);
				WiseStampUI.addSignatureToCombo($('#signatureSelect'), id, title, true);
				WiseStampEditor.setCurrentSignature(id);
				
				if (WiseStampUser.loggedIn())
					WiseStampWizard.open("content/src/wizard/steps/details.htm", "create_signature");
				else
					WiseStampWizard.open("content/src/wizard/steps/account.htm", "create_signature");
			});
	}
	
	this.onOpenWizard = function() {
		if (WiseStampUser.loggedIn())
			WiseStampWizard.open("content/src/wizard/steps/details.htm", "create_signature");
		else
			WiseStampWizard.open("content/src/wizard/steps/account.htm", "create_signature");
	}
	
	this.onRenameSignature = function()
	{
		var id = $('select#signatureSelect option:selected').attr('id');
		var signature = WiseStampController.getData().signatures[id];
		
		var form = new WiseStampFormDlg();
		form.addTextInput('name',WiseStampLocale.getLocalizedMessage("editor_signature_name"),signature.title);
		
		form.show(
			'rename',350,undefined,
			function()
			{
				var title = form.getTextValue('name');
				if (title == '')
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_signature_name_enter_valid"));
					return false;
				}
				
				if (WiseStampController.signatureTitleExists(title))
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_signature_name_unique"));
					return false;
				}
				
				signature.title = title;
				$('select#signatureSelect option:selected').html(title);
			});
	}
	
	this.onDeleteSignature = function()
	{
		function isMapped(id)
		{
			var mappings = WiseStampController.getData()['mappings'];
			for (var sender in mappings) 
			{
				if (id == mappings[sender].composeSigId ||
					id == mappings[sender].replySigId)
					return true;
			}
			
			return false;
		}
		
		function cleanMapped(id,defaultId)
		{
			var mappings = WiseStampController.getData()['mappings'];
			for (var sender in mappings) 
			{
				if (mappings[sender].composeSigId == id)
				{
					mappings[sender].composeSigId = defaultId;
					WiseStampEditor.mMappingsModified = true;
				}
				
				if (mappings[sender].replySigId == id)
				{
					mappings[sender].replySigId = mappings[sender].composeSigId;
					WiseStampEditor.mMappingsModified = true;
				}
			}
		}
		
		function deleteSignature(element,id)
		{
			element.remove();
			delete WiseStampController.getData().signatures[id];

			var firstId = WiseStampUtils.objectKeys(WiseStampController.getData().signatures)[0];
			cleanMapped(id,firstId);

			WiseStampEditor.setCurrentSignature(firstId);
		}
		
		var selected = $('select#signatureSelect option:selected');
		var id = selected.attr('id');
		var title = WiseStampController.getData().signatures[id].title;
		
		if (WiseStampController.signaturesCount() == 1)
		{
			WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_signature_cannot_delete"));
			return;
		}
		
		var question = '';
		if (id == WiseStampController.defaultSigId())
			question = WiseStampLocale.getLocalizedMessage("editor_signature_delete_default");
		
		if (question == '')
			question = WiseStampLocale.getLocalizedMessage("editor_signature_delete_question", title);//question = 'Are you sure you want to delete ['+title+'] signature?';
		
		WiseStampUI.confirm(
				question,
				function(){deleteSignature(selected,id);}
			);
	}
	
	this.onTemplateSelect = function()
	{
		WiseStampAnalytics.trackEvent('editor','templatesView');
		
		WiseStampController.getStorage().loadParam("beenToWizardTemplates", function(found) {
				if (found == true) {
					WiseStampWizard.open("content/src/wizard/steps/templates.htm", "templates");
				}
				else {
					var defaultQuery = [
							["photo", "http://images.wisestamp.com/templates/logo_vert.png"],
							["name", "John Smith"],
							["company", "Smith Designs"],
							["title", "Designer"],
							["phone", "(555) 555-5555"],
							["mobile", "(555) 555-5555"],
							["address", "New York, NY 4321"],
							["website", "www.smithdesigns.com"],
							["email", "john@johnsite.com"]
						
						].map(function(x){x[1] = encodeURIComponent(x[1]); return x.join('=')}).join('&');
						
					var templates = new WiseStampTemplates;
					templates.init($("#templatesDialog"), {
							beforeload: function(self) {
									self.content.dialog({
											title: 'Templates Gallery',
											bgiframe: true,
											height: 550,
											width: 520,
											modal: true,
											buttons: {
													"Close": function() {
														self.content.dialog('close')
													}
												}
										});

									self.content.dialog('open');
								},
							
							dataAvailable: function(self) {
									var data = self.data.replace(/[\r\n\t]/g, "");
									var match = data.match(/(.+)<body>(.+)<\/body>(.+)/);
									if (typeof match != "object" && match.length != 4)
										return false;
									
									var body = WiseStampTemplateMgr.renderData(match[2], function getQuery(name) {
											debugger;
											return defaultQuery["post-" + name];
										});
									
									self.data = match[1] + body + match[3];
								},
							
							click: function(self, event) {
									WiseStampAnalytics.trackEvent('editor','templateSelect');
									
									var element = $(event.target);
									var html = element.parents('div.template:first').find('.html').html();
									WiseStampHtmlEditor.setContent(html + '<br/>' + WiseStampHtmlEditor.getContent());
									self.content.dialog('close');
								}
						},
						undefined,
						undefined,
						defaultQuery);
				}
			});
	}
	
	function refreshFacebookApps()
	{
		var data = WiseStampController.getData();
		
		for (var signature_id in data.signatures) {
			var apps = WiseStampController.getAppsMgr(signature_id).getApps();
			
			for (var id in apps) {
				var app = apps[id];
				
				if (app.mRefreshOnStatusChange) {
					app.refreshData();
					
					if (WiseStampEditor.getCurrentSignature() == signature_id)
						WiseStampAppsView.updateActiveApp(id, app);
				}
			}
		}
	}
	
	function updateUserStatus()
	{
		// first check if the controller is ready
		// (may not be if working remotely)
		if (WiseStampController.ready() == false)
			return;
			
		if (WiseStampUser.loggedIn() == true)
		{
			$('.usermenu#loggedin #name').html(WiseStampLocale.getLocalizedMessage("editor_welcome") + WiseStampUser.name());
			$('.usermenu#loggedin').show();
			$('.usermenu#loggedout').hide();
			
		} else
		{
			$('.usermenu#loggedin').hide();
			$('.usermenu#loggedout').show();
		}
		
		if (WiseStampUser.loggedIn() == false || WiseStampUser.plan() == WiseStampUser.PLAN_FREE)
			$('span#upgrade').show();
		else
			$('span#upgrade').hide();
		
		var fbToken = WiseStampUser.fbToken();
		if (typeof fbToken == 'string' && fbToken != "")
			$('.usermenu#facebookConnect').hide()
		else
			$('.usermenu#facebookConnect').show()
		
		// email apps tag
		if (WiseStampUser.featureSupported('emailAppsTag',true))
			$('#addEmailAppsTag').attr('checked',false);
		else {
			//alert(JSON.stringify(WiseStampController.getData()));
			$('#addEmailAppsTag').attr('checked',WiseStampController.getData().prefs.emailAppsTag);
		}
		
		refreshFacebookApps();
		refreshServicesTab(true);
		WiseStampEditor.footerSocialButtons();
		WiseStampSettingsDlg.close();
	}
	
	this.loginByCookie = function(callback) {
		WiseStampUtils.getCookies("http://www.wisestamp.com", "extension_*", function(cookies) {
				if (WiseStampUtils.isEmpty(cookies.extension_username, cookies.extension_password))
					return false;
				
				WiseStampUser.login(cookies.extension_username, cookies.extension_password, function(status, error) {
						function callback_inner(status, error)
						{
							WiseStampEditor.onDataUpdated();
							WiseStampEditor.onUserStatusChanged();
							if (typeof callback == "function")
								callback(status);
						}

						if (status && !WiseStamp.config.support.offline)
							return WiseStampController.load(function(){callback_inner(true);});

						callback_inner(status, error);
					}, true);
			});
		
	}
	
	this.onLogin = function(callback_out)
	{
		var form = new WiseStampFormDlg('login');
		
		this.onForgotPassword = function()
		{
			var formReset = new WiseStampFormDlg('resetPassword');
			formReset.async(true);
			formReset.title(WiseStampLocale.getLocalizedMessage("editor_password_reset"));
			formReset.addHtml(WiseStampLocale.getLocalizedMessage("editor_password_reset_email_message"));
			formReset.addTextInput('username',WiseStampLocale.getLocalizedMessage("editor_email"),form.getTextValue('username'));
			formReset.addHtml('<br/>');
			
			formReset.show('resetPassword',undefined,undefined,
				function(values,resetCallback){
					WiseStampUser.resetPassword(
						values['username'],
						function(status,error)
						{
							if (formReset.dialog().is(":visible") == false) // cancelled
								return;
							
							WiseStampUI.stopWaiting(formReset.dialog());
							if (status == false)
							{
								alert(error);
								resetCallback(false);
								return;
							}
							
							WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_password_reset_email_sent"));
							resetCallback(true);
						});
				});
		}
		
		form.async(true);
		form.title('WiseStamp User Sign in');
		form.addHtml(WiseStampLocale.getLocalizedMessage("editor_user_sign_in_manually"));
		form.addTextInput('username',WiseStampLocale.getLocalizedMessage("editor_email"),WiseStampUser.username());
		form.addPasswordInput('password',WiseStampLocale.getLocalizedMessage("editor_password"));
		
		var forgotElement = $(WiseStampLocale.getLocalizedMessage("editor_password_forgot"));
		forgotElement.click(function(){return WiseStampEditor.onForgotPassword();});
		form.addItem(' ',forgotElement);
		
		form.addItem(WiseStampLocale.getLocalizedMessage("editor_create_account_message"));

		//if (WiseStamp.config.support.offline == false)
			//form.cancelSupported(false);
		
		var thisObj = this;
		form.show('login', 500, undefined, function(values, callback) {
				WiseStampUser.login(values['username'], values['password'], function(status, error) {
						function callback_inner(status, error)
						{
							WiseStampUI.stopWaiting(form.dialog());
						
							if (status == false)
								alert(error);
							
							WiseStampEditor.onDataUpdated();
							WiseStampEditor.onUserStatusChanged();
							callback(status);
							
							if (status == true && typeof callback_out != 'undefined')
								callback_out();
						}
						
						if (form.dialog().is(":visible") == false) // cancelled
							return;

						if (status && !WiseStamp.config.support.offline)
							return WiseStampController.load(function(){callback_inner(true);});

						callback_inner(status, error);
					}, true);
			});
		
		form.dialog().append('<div id="fbconnect-wrap"><h2>' + WiseStampLocale.getLocalizedMessage("editor_create_account_facebook") + '</h2></div>');
		var fbLoginLink = $("#fbconnect-wrap").append('<a id="fbconnect"><img src="../img/connectwithfb.jpg" /></a>');
		fbLoginLink.click(function(){
				var registerForm = form;
				thisObj.onFbLogin(form.dialog(),function(){
						form.dialog().dialog('close')
					});
			});

		form.dialog().append('<div id="separator"><span>' + WiseStampLocale.getLocalizedMessage("editor_or") + '</span></div>');
		form.dialog().append('<div style="clear:both"></div>');
		
		$('#loginRegister').click(function(){
				form.dialog().dialog('close');
				WiseStampEditor.onRegister();
			});
	}
	
	this.onFbLogin = function(container, callback)
	{
		if (typeof container == 'undefined')
			container = $('body');
		
		WiseStampUI.startWaiting(container);
		
		WiseStampUser.fbConnect(function(status,error){
				WiseStampUI.stopWaiting(container);
				if (container.is(":visible") == false) // cancelled
					return;
			
				if (status == false)
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_facebook_allow_message"));
					return;
				}
				
				WiseStampEditor.onDataUpdated();
				WiseStampEditor.onUserStatusChanged();
				
				if (typeof callback != 'undefined')
					callback();
			});
	}
	
	this.onRegister = function(callback_out, hideWelcomeScreen, hideSignIn)
	{
		var thisObj = this;
		var form = new WiseStampFormDlg('register');
		
		form.async(true);
		form.title(WiseStampLocale.getLocalizedMessage("editor_create_account"));
		
		//if (WiseStamp.config.support.offline == false)
			//form.cancelSupported(false);
			
		// manual
		form.addHtml('<h2>' + WiseStampLocale.getLocalizedMessage("editor_sign_up_manually") + '</h2>');
		form.addTextInput('name',WiseStampLocale.getLocalizedMessage("editor_name"),'',true);
		form.addTextInput('username',WiseStampLocale.getLocalizedMessage("editor_email"),'',true);
		form.addPasswordInput('password',WiseStampLocale.getLocalizedMessage("editor_password"),'',true);
		
		if (hideSignIn == false || typeof hideSignIn == "undefined") {
			form.addItem(WiseStampLocale.getLocalizedMessage("editor_account_sign_in"));
		}
		//form.addHtml('<div id="fb-root"></div><fb:login-button show-faces="false" width="200" max-rows="1"></fb:login-button>');


		var thisObj = this;
		form.show('register',520,undefined,
			function(values,callback){
				if (WiseStampUser.validEmail(values['username']) == false)
				{
					WiseStampUI.showPopup(WiseStampLocale.getLocalizedMessage("editor_enter_valid_email"));
					callback(false);
					return false;
				}
				
				WiseStampUser.register(
					values['name'],values['username'],values['password'],
					function(status,error)
					{
						if (form.dialog().is(":visible") == false) // cancelled
							return;
						
						if (status == false)
						{
							WiseStampUI.showPopup(error);
							callback(false);
							return;
						}
						
						WiseStampEditor.onDataUpdated();
						WiseStampEditor.onUserStatusChanged();
						callback(true);
						if (typeof callback_out == "function")
							callback_out();
						
						if (hideWelcomeScreen == false || typeof hideWelcomeScreen == "undefined") {
							var content = $('#afterRegisterPopup').parent();
							content.attr('title',WiseStampLocale.getLocalizedMessage("editor_welcome_title"));
							content.dialog({ bgiframe: true, width: 420, modal: true, buttons:
									{
										'Not now, thanks':function(){
												$(this).dialog('close');
											}
									}});
							
							content.dialog('open');
						}
					});
			});
		
		form.dialog().append('<div id="fbconnect-wrap"><h2>' + WiseStampLocale.getLocalizedMessage("editor_sign_up_facebook") + '</h2></div>');
		var fbLoginLink = $("#fbconnect-wrap").append('<a id="fbconnect"><img src="../img/connectwithfb.jpg" /></a>');
		fbLoginLink.click(function(){
				var registerForm = form;
				thisObj.onFbLogin(form.dialog(),function(){
						form.dialog().dialog('close')
					});
			});

		form.dialog().append('<div id="separator"><span>' + WiseStampLocale.getLocalizedMessage("editor_or") + '</span></div>');
		
		form.dialog().append('<div style="clear:both"></div>');
		form.dialog().append(WiseStampLocale.getLocalizedMessage("editor_accept_policy"));
		form.dialog().find('a#terms').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.terms,true)});
		form.dialog().find('a#privacy').click(function(){WiseStampEditor.openLink(WiseStamp.config.URLs.website.privacy,true)});
		
		$('#registerLogin').click(function(){
				form.dialog().dialog('close');
				WiseStampEditor.onLogin();
			});
	}
	
	this.onUpgrade = function(medium,campaign)
	{
		WiseStampUser.upgrade(medium,campaign);
	}
	
	this.onManagePlan = function()
	{
		WiseStampEditor.openLink(WiseStamp.config.URLs.website.manage,true);
	}
	
	this.setData = function(data)
	{
		WiseStampController.clearData();
		
		if (typeof data != 'undefined')
			WiseStampController.setData(data,false);
		
		var selectElement = $('#signatureSelect');
		WiseStampUI.populateSignaturesCombo(selectElement, WiseStampController.getSignaturesList(), WiseStampController.defaultSigId());
		WiseStampEditor.setCurrentSignature(WiseStampController.defaultSigId());
	}
	
	this.onUserStatusChanged = function()
	{
		updateUserStatus();
		sendDataUpdate();
		WiseStampController.filterMappingsSet();
		
		if (!WiseStamp.config.support.offline)
		{
			if (WiseStampUser.loggedIn())
			{
				WiseStampEditor.onUserAvailable();
			} else {
				WiseStampEditor.setData();
				WiseStampEditor.onDataUpdated();
			}
		}
	}
	
	this.onDataUpdated = function()
	{
		var selectElement = $('#signatureSelect');
		WiseStampUI.populateSignaturesCombo(selectElement, WiseStampController.getSignaturesList(), WiseStampController.defaultSigId());
		WiseStampEditor.setCurrentSignature(WiseStampController.defaultSigId());
	}
	
	this.onLogout = function()
	{
		WiseStampUser.logout();
		WiseStampEditor.onUserStatusChanged();
		
		if (!WiseStamp.config.support.offline)
			WiseStampWizard.open("content/src/wizard/steps/index.htm", "first_time");//, "fullscreen=yes");
	}
	
	this.onAccountSettings = function()
	{
		WiseStampSettingsDlg.show('account');
	}
	
	function downgrade()
	{
		WiseStampUI.confirm(
			WiseStampLocale.getLocalizedMessage("editor_localstorage_confirm"),
			function(){
				WiseStampStorage.clear();
				WiseStampLocalStorage.save(WiseStampController.getData());
			});
	}
	
	this.onEditImSettings = function()
	{
		WiseStampEditor.mImTab.editSettings(WiseStampController.getData(),mCurrentId);
	}
	
	this.onEditSocialSettings = function()
	{
		WiseStampEditor.mSocialTab.editSettings(WiseStampController.getData(),mCurrentId);
	}
	
	this.onEditCustomIcons = function()
	{
		if (WiseStampUser.featureSupported('customIcons') == false)
			return;
	
		WiseStampEditor.saveCurrentSignature();
		
		var dlg = $('#customIconsDialog');
		if (dlg.attr('firsttime') != 'true')
		{
			dlg.attr('firsttime','true');
			dlg.find('a#addCustomIcon').click(onAddCustomIcon);
		}
		
		function close()
		{
			dlg.dialog('close');
		}
		
		function getIconId(name)
		{
			return name;
		}
		
		function save()
		{
			var icons = {};
			dlg.find('tr.icon').each(function(i,obj){
					var name = $(obj).find('td.name').text();
					var url = $(obj).find('.value input').val();
					//var name = $(obj).find('div.iconName').text();
					//var url = $(obj).find('input').val();
					icons[getIconId(name)] = {name:name,url:url};
				});
			
			WiseStampController.getData().customIcons = icons;
			
			refreshServicesTab(true);
			close();
		}
		
		function iconInUse(id)
		{
			var signatures = WiseStampController.getData().signatures;
			for (var sigId in signatures)
			{
				var services = signatures[sigId].socialServices;
				for (var serviceId in services)
				{
					if (services[serviceId].id == id)
						return true;
				}
			}
			
			return false;
		}
		
		function deleteCustomIcon(element)
		{
			var name = element.find('td.name').text();
			var id = 'custom:'+getIconId(name);
			
			if (iconInUse(id))
			{
				WiseStampUI.confirm(
					WiseStampLocale.getLocalizedMessage("editor_icon_in_use"),
					function(){
							var signatures = WiseStampController.getData().signatures;
							for (var sigId in signatures)
							{
								var services = signatures[sigId].socialServices;
								for (var serviceId in services)
								{
									if (services[serviceId].id == id)
										delete services[serviceId];
								}
							}
							
							element.remove();
						});
			} else
				element.remove();
		}
		
		function addCustomIcon(name,url)
		{
			var table = dlg.find('table');
			
			var row = $('<tr class="icon" width="1%" />');
			row.append('<td class="icon"><img width="16px" src="'+url+'"></td>');
			row.append('<td class="name" width="25%">'+name+'</td>');
			row.append('<td class="value"><input value="'+url+'"/></td>');
			
			var delElement = $('<td width="1%" class="actions"></td>');
			var delAction = $('<a><div class="delete"></div></a>');
			delAction.click(function(){deleteCustomIcon($(this).parent().parent())});
			delElement.append(delAction);
			row.append(delElement);
			
			table.append(row);
			row.find('.value input').change(function(){
					var row = $(this).parent().parent();
					var icon = row.find('td.icon img');
					icon.attr('src',$(this).val());
				});
			
		}
		
		function addCustomIcon_list(name,url)
		{
			var iconsContainer = dlg.find('table');
			
			var row = $('<tr valign="top" class="icon" />');
			row.append('<td width="24px"><img class="icon" width="16px" src="'+url+'"></td>');
			
			var iconDetails = $('<td></td>');
			iconDetails.append(
				'<div class="iconName">' + name + '</div>' +
				'<input style="width:100%" value="'+url+'"/>');
			
			var delAction = $('<a>' + WiseStampLocale.getLocalizedMessage("editor_delete") + '</a>');
			delAction.click(function(){deleteCustomIcon($(this).parent().parent())});
			iconDetails.append(delAction);
			
			iconDetails.find('input').change(function() {
					var row = $(this).parent().parent();
					var icon = row.find('img.icon');
					icon.attr('src',$(this).val());
				});
				
			row.append(iconDetails);
			iconsContainer.append(row);
		}
		
		function showIconDetailsDlg(name,url,callback)
		{
			var form = new WiseStampFormDlg();
			form.addParams(
				{
					name:	{type:'text', 	label:'Service name',	required: true},
					link:	{type:'text', 	label:'Icon location',	required: true, 'description':	'The image should be hosted online. Typically, the location will have "ico", "gif", "png" or "jpg" at the end.'}
				}, ':');
			
			//form.addTextInput('name','Name:',name,true);
			//form.addTextInput('url','Icon location:',url,true);
			
			form.show(
				'addCustomIconForm',350,undefined,
				function()
				{
					var link = form.getTextValue('link');
					var name = form.getTextValue('name');
					
					var match = link.match(/^https?:\/\//);
					if (!match)
						link = 'http://' + link;
					
					callback(name,link);
				});
		}
		
		function onAddCustomIcon()
		{
			showIconDetailsDlg('','',function(name,url){
					addCustomIcon(name,url);
				});
		}
		
		dlg.find('table').find('tr.icon').remove();
		
		for (var id in WiseStampController.getData().customIcons)
		{
			var icon = WiseStampController.getData().customIcons[id];
			addCustomIcon(icon.name,icon.url)
		}
		
		dlg.attr('title', WiseStampLocale.getLocalizedMessage("editor_custom_icons"));	
		var buttonsObject = {};
		buttonsObject[WiseStampLocale.getLocalizedMessage("editor_cancel")] = close;
		buttonsObject[WiseStampLocale.getLocalizedMessage("editor_ok")] = save;
		dlg.dialog({ bgiframe: true, height:350, width:450, modal: true, buttons: buttonsObject});
		dlg.dialog('open');
		
		// remove selection from the input element
		window.setTimeout(function(){
				var input = dlg.find('input:first');
				if (input.length == 0)
					return;
				
				input[0].selectionStart=input[0].selectionEnd=-1;
				input[0].blur();
			},0);
	}
	
	this.onAddImService = function()
	{
		WiseStampEditor.mImTab.addService();
	}
	
	this.onAddSocialService = function()
	{
		WiseStampEditor.mSocialTab.addService();
	}
	
	this.onOK = function(runAfterSaveDialog)
	{
		var thisObj = this;
		this.save(
			function(){
				if (thisObj.mFirstTimeEditor || runAfterSaveDialog)
				{
					var buttons = {
						"Close": function() {
							WiseStampAnalytics.trackEvent('wizard', 'take_to_inbox', 'close', 1);
							WiseStampQuery(this).dialog('close');
							WiseStampQuery(this).remove();
							WiseStampEditor.close();
							if (typeof callback != 'undefined')
								callback();
						}
					}
					var drop = '';
					
					if(!WiseStamp.sys.email_client) {
						var pics = '';
						for(var i in thisObj.COMPOSE_LINKS) {
							pics += '<img class="mail_icon" src="'+thisObj.COMPOSE_LINKS[i].img+'" data-url="'+thisObj.COMPOSE_LINKS[i].url+'" data-service="'+i+'" style="cursor:pointer" />';
							if(i == 'yahoo')
								pics += '<br>';
						}
						drop =	'<div id="open_email" style="display:table;margin:0 auto">';
						drop +=		'<br>Click your webmail for a quick start:<br>';
						drop +=		pics;
						drop += '</div>';
					}
						
					var msg = WiseStampQuery('<div style="text-align:center">' + WiseStampLocale.getLocalizedMessage("editor_signature_will_appear") + drop + '</div>');
					
					if(WiseStamp.sys.application != 'Thunderbird') {
						WiseStampUI.showDialog(msg, buttons, null, null, null);
					}
				
					if(!WiseStamp.sys.email_client) {
						$('.mail_icon').click(function(){
							WiseStampAnalytics.trackEvent('wizard', 'email_icon', $(this).attr('data-service'), 1);
							var mail_url = $(this).attr('data-url');
							WiseStampUtils.openWindow(mail_url);
							WiseStampEditor.close();
						});
					}
					else {
						if(WiseStamp.sys.application == 'Thunderbird' && runAfterSaveDialog) {
							var msgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService(Components.interfaces.nsIMsgComposeService);
							// make the URI
							var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
							aURI = ioService.newURI("mailto:?", null, null);
							// open new message
							msgComposeService.OpenComposeWindowWithURI(null, aURI);
						}
						WiseStampEditor.close();
					}					
				} else {
					WiseStampEditor.close();
				}
			});
	}
	
	this.getServiceByEmail = function(email) {
		var service = false;
		if(email.match(/(@gmail|@google)/)) {
			service = WiseStampEditor.COMPOSE_LINKS.gmail;
		}
		if(email.match(/(@yahoo)/)) {
			service = WiseStampEditor.COMPOSE_LINKS.yahoo;
		}
		if(email.match(/(@hotmail|@outlook)/)) {
			service = WiseStampEditor.COMPOSE_LINKS.hotmail;
		}
		if(email.match(/(@aol)/)) {
			service = WiseStampEditor.COMPOSE_LINKS.aol;
		}

		return service;
	}
	
	this.COMPOSE_LINKS = {
			"gmail":{name: "GMail", url: 'https://mail.google.com/mail/u/0/?shva=1#compose', img:'wizard/steps/img/gmail.gif'},
			"yahoo":{name: "Yahoo! Mail", url: 'http://compose.mail.yahoo.com/', img:'wizard/steps/img/yahoo.jpg'},
			"hotmail":{name: "Hotmail/Outlook.com", url: 'http://mail.live.com/mail/EditMessageLight.aspx?n=&to=TO&cc=CC&subject=SUBJECTt&body=BODY', img:'wizard/steps/img/hotmail.jpg'},
			"aol":{name: "AOL", url: 'http://webmail.aol.com/30361-111/aol-1/en-us/compose-message.aspx?to=example@email.com&subject=Hello', img:'wizard/steps/img/aolmail.jpg'}
		};
	
	this.onCancel = function(compact)
	{
		WiseStampEditor.saveCurrentSignature();
		
		if (WiseStampController.modified() == true)
		{
			if (compact == true)
				return WiseStampLocale.getLocalizedMessage("editor_changes_not_saved");
			
			var dialogObject = {};
			dialogObject[WiseStampLocale.getLocalizedMessage('editor_return_to_editor')] = function() { 
							$(this).dialog("close");
						}; 
			dialogObject[WiseStampLocale.getLocalizedMessage('editor_discard')] = function() {
							WiseStampController.modified(true);
							
							$(this).dialog("close");
							WiseStampEditor.close();
						};
			dialogObject[WiseStampLocale.getLocalizedMessage('editor_save')] = function() {
							$(this).dialog("close");
							WiseStampEditor.onOK();
						};
			WiseStampUI.showDialog(
					WiseStampLocale.getLocalizedMessage("editor_changes_not_saved_question"),
					{
						'Return to editor' : function() {              
							$(this).dialog("close");
						},
						
						Discard : function() {
							WiseStampController.modified(true);
							
							$(this).dialog("close");
							WiseStampEditor.close();
						},
						
						Save : function() {
							$(this).dialog("close");
							WiseStampEditor.onOK();
						}
					}, undefined, undefined, 305
				);
		} else {
			WiseStampEditor.close();
		}
		
		return null;
	}
	
	this.close = function()
	{
		switch (WiseStamp.sys.platform)
		{
		case 'safari':
		case 'chrome':
			window.removeEventListener("beforeunload", this.mBeforeunload, false);
			window.close();
			break;
		
		case 'web':
		case 'conduit':
		case 'mozilla':
			window.parent.close();
			break;
			
		default:
			window.close();
			break;
		}
	}
	
	this.openLink = function(link,wrap)
	{
		if (wrap == true)
			WiseStampUtils.openWindow(link,'extension','editor','editor');
		else
			WiseStampUtils.openWindow(link);
	}
	
	/////////////////////////////////////////////////////////////////
	
	this.regsiterForConduitMessage = function(messageID, callback)
	{
		if (messageID in this.mConduitMsgClients == false)
			this.mConduitMsgClients[messageID] = {};
			
		mConduitMsgClients[messageID][callback] = true;
	}
	
	this.onConduitMessageReceived = function(messageID, param) 
	{
		WiseStampUtils.log("[htmlComponent.html::onConduitMessageReceived] messageID = "+messageID+", param = "+param);
		switch (messageID)
		{
			case 'wisestampFbConnectCompleted':
				WiseStampUser.onFbWindowClosed();
				break;
				
			default:
				if (messageID in this.mConduitMsgClients)
				{
					for (callback in this.mConduitMsgClients[messageID])
						callback();
				}
				break;
		}
	}
	
	/////////////////////////////////////////////////////////////////
	
	this.footerSocialButtons = function()
	{
		var share_twitter_text = WiseStampLocale.getLocalizedMessage("editor_twitter_text");
		if (WiseStamp.sys.platform == "mozilla") {
			var html = [];
			// in Mozilla the #twitter-button iframe throws an error when clicked, replacing it with <a>.
			html.push('<a id="moz-twitter-button"><img src="' + WiseStamp.getURL("content/img/twitter_button.png") + '" /></a>');
			html.push('<div id="fb-invite-button">&nbsp;</div>');
			
			$("#footerSocialButtons").html(html.join(''));
			
			$("#moz-twitter-button").click(function() {
					WiseStampUtils.openWindow(WiseStamp.config.URLs.APIs.share_twitter + share_twitter_text);
				});
		}
		else {
			var html = [];
			
			html.push('<iframe scrolling="no" frameborder="0" id="twitter-button" src="http://platform0.twitter.com/widgets/tweet_button.html?_=1310283512158&amp;count=none&amp;id=twitter_tweet_button_0&amp;lang=en&amp;original_referer=http%3A%2F%2Fwww.wisestamp.com%2Fplans&amp;text=' + share_twitter_text + '"></iframe>');
			html.push('<iframe scrolling="no" frameborder="0" id="like-button" src="http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.facebook.com%2Fwisestamp&layout=button_count&show_faces=false&width=80&action=like&colorscheme=light&height=21"></iframe>');

			if(WiseStampUser.fbToken()) {
				html.push('<div id="fb-invite-button">&nbsp;</div>');
			}
			
			$("#footerSocialButtons").html(html.join(""));
		}
	
		//this button shows in both webkit and mozilla
		$('#fb-invite-button').click(function(){
			var widthHeight = "";
			if(WiseStamp.sys.platform == 'mozilla') {	//if we're in FF we need to specify the popup size
				var xdelta = (window.outerWidth-window.innerWidth)/4;
				widthHeight = ",left="+(window.screenX+xdelta)+",top="+(window.screenY+xdelta)+",width="+window.innerWidth+",height="+window.innerHeight;
			}
			else {
				widthHeight = ",left="+window.screenX+",top="+window.screenY;
			}
			
			var url = 'https://www.facebook.com/dialog/send?app_id=192808560736136'+
					'&name=Check%20out%20WiseStamp'+
					'&link=http://www.wisestamp.com/%3Ft='+(new Date()).getTime()+'%26utm_source=invite%26utm_medium=facebook%26utm_campaign=inapp_invite%26utm_term=platform:'+WiseStamp.getPlatform()+'%26utm_content=plan:'+WiseStampUser.plan()+
					'&redirect_uri=http://static.wisestamp.com/after_invite_land.html'+
					'&display=popup';
			
			if(WiseStamp.sys.application == 'Thunderbird') {
				WiseStampUtils.openDialog(url, "Facebook Invite", window.innerHeight, window.innerWidth);
			}
			else {
				window.open(url,
					"Facebook Invite", "modal=yes,alwaysRaised=yes"+widthHeight);
					WiseStampAnalytics.trackEvent('editor', 'invite', 'facebook');
			}
		});
	}
}

$(document).ready(function(arg) {
		$().blur(function(){return false;});			
	});
	
$(window).load(function() {
	WiseStampEditor.init();
})

//WiseStampHtmlEditor.init('textarea',WiseStampEditor.init);

//WiseStampUtils.wrapWithTrace(WiseStampEditor,'WiseStampEditor');
WiseStampUtils.wrapWithCatch(WiseStampHtmlEditor,'WiseStampHtmlEditor');
