WiseStampAnalytics.trackEvent('editor','tour','displayed');
var WiseStampFirstTimeTour = new function()
{
	this.mShown = false;
	
	var mSlides = [];
	var mSlidesCount = 0;
	var mSlidesFactory = {};
	
	var editor = null;
	
	function close()
	{
		if (WiseStamp.config.support.apps)
			$('.tab#apps').click();
		else
			$('.tab#social').click();
			
		$('.slide').remove();
	}

	function getSlide(iSlide)
	{
		if (typeof mSlides[iSlide] != 'undefined')
			return mSlides[iSlide];
		
		var slide = $('<div></div>');
		slide.attr("class", "slide");
		slide.attr("id", "iSlide");
		slide.css({display:'none'});
			
		mSlides[iSlide] = mSlidesFactory[iSlide](slide,iSlide);
		$('#content').append(slide);
		
		return mSlides[iSlide];
	}
		
	function moveSlides(iCurrent,iNew)
	{
		switch (iNew)
		{
		case 1:
			if (iCurrent == 0)
				WiseStampAnalytics.trackEvent('editor','tour','played');

			break;
		
		case 3:
			if (WiseStamp.config.support.apps)
				$('.tab#social').click();
			else
				$('.tab#rss').click();
				
			break;
		
		default:
			if (WiseStamp.config.support.apps)
				$('.tab#apps').click();
			else
				$('.tab#social').click();
				
			break;
		}

		var currentSlide = getSlide(iCurrent);
		var newSlide = getSlide(iNew);
								
		currentSlide.hide();
		newSlide.show();
		return;
		
		currentSlide.animate({'left': '-600'}, 500, 'linear', function(){currentSlide.remove()});

		newSlide.css({position:'absolute',width:'100%',top: 0,left:'600'});
		$('#content').append(newSlide);
		newSlide.animate({'left': '0'}, 500, 'linear');
		
		currentSlide.css({position:'absolute',width:'100%',top: 0,left:0});
		currentSlide.animate({'left': '600'}, 500, 'linear', function(){currentSlide.remove()});

		newSlide.css({position:'absolute',width:'100%',top: 0,left:'-600'});
		$('#content').append(newSlide);
		newSlide.animate({'left': '0'}, 500, 'linear');
	}
	
	function addShadow(parent,whiteAreas,background,opacity)
	{
		if (typeof background == 'undefined')
			//background = '#6e8c93';
			background = 'black';
			 
		if (typeof opacity == 'undefined')
			opacity = '0.67';
		
		function getPiece(xStart,yStart,xEnd,yEnd,background,opacity)
		{
			var piece = $('<div></div>');
			piece.css({
					position: 'absolute',
					left: xStart, top: yStart, width: xEnd-xStart, height: yEnd-yStart,
					background: background, opacity: opacity
				});
				
			return piece;
		}
		
		var bgElements = $('<div id="shadow"></div>');
		
		var x = 0;
		var y = 0;
		var width = $('#content').outerWidth();
		var height = $('#content').outerHeight();
		
		for (var i=0; i < whiteAreas.length; i++)
		{
			var area = whiteAreas[i];
			area = {xStart:area.xStart-2, yStart:area.yStart-2, xEnd:area.xEnd, yEnd:area.yEnd};
			
			var selection = getPiece(area.xStart,area.yStart,area.xEnd-8,area.yEnd-8,'','1');
			selection.css({border:'4px solid #ffd200', '-moz-border-radius': '0px', '-webkit-border-radius': '0px'});
			
			bgElements.append(getPiece(0,y,width,area.yStart,background,opacity));
			bgElements.append(getPiece(0,area.yStart,area.xStart,area.yEnd,background,opacity));
			bgElements.append(selection);
			bgElements.append(getPiece(area.xEnd,area.yStart,width,area.yEnd,background,opacity));
			y = area.yEnd;
		}
		bgElements.append(getPiece(0,y,width,height,background,opacity));
		
		parent.append(bgElements);
	}
	
	function addNavigationControls(slide,iSlide)
	{
		var arrows = $('<div></div>');
		arrows.css({
				'float': 'right',
				'margin-right': '11px',
				'font-weight': 'bold'
			});
			
		var arrowLeft = $('<span>&#x25c4; back</span>');
		arrowLeft.css({float:'right'});
		if (iSlide > 1)
		{
			arrowLeft.css({color:'#eee',cursor:'pointer'});
			arrowLeft.click(function(){moveSlides(iSlide,iSlide-1)});
			arrowLeft.hover(
				function(){$(this).css({color:'white'});}, function(){$(this).css({color:'eee'})});
		}
		else
			arrowLeft.css({color:'#777'});
		
		var arrowRight = $('<span>next &#x25ba;</span>');
		arrowRight.css({float:'right'});
		if (iSlide < mSlidesCount-1)
		{
			arrowRight.css({color:'#eee',cursor:'pointer'});
			arrowRight.click(function(){moveSlides(iSlide,iSlide+1);});
			arrowRight.hover(
				function(){$(this).css({color:'white'});}, function(){$(this).css({color:'eee'})});
		}
		else
			arrowRight.css({color:'#777'});
		
		
		var slideNumbers = $('<span></span>');
		slideNumbers.css({float:'right'});
		for (var iSlideNumber = 1; iSlideNumber < mSlidesCount; iSlideNumber++)
		{
			var slideNumber = $('<div>'+iSlideNumber+'</div>');
			slideNumber.css({
				'-moz-border-radius': '25px', 'border-radius': '25px', '-webkit-border-radius': '25px', color: '#aaa', 'font-size': '75%',
				float:'left', width:'20px',height:'20px','text-align':'center','line-height':'140%'});
				
			if (iSlideNumber == iSlide)
			{
				slideNumber.css({background:'#ffd200', color:'white'});
			}
			
			slideNumbers.append(slideNumber);
		}

		arrows.append(arrowRight).append('<span style="float: right">&nbsp;&nbsp;&nbsp;</span>');
		arrows.append(slideNumbers).append('<span style="float: right">&nbsp;&nbsp;&nbsp;</span>');
		arrows.append(arrowLeft);
		
			
		var closeButton = $('<div>Exit the tour</div>');
		closeButton.click(close);
		closeButton.css({
				float:'left','margin-left': '13px', 'font-size':'18px',cursor:'pointer', color: 'eee'
			});
		closeButton.hover(
			function(){$(this).css({color:'white'});}, function(){$(this).css({color:'eee'})});
		
		var headerControls = $('<div></div>');
		headerControls.append(closeButton);
		headerControls.append(arrows);
		
		headerControls.css({
				'font-family':'arial', 'font-size':'20px',
				'position':'absolute', 'width': '100%', 'padding':'3px 0px 0px 0px',
				'top':0,'left':0, 'height': 25,
				'background': 'black' 
			});
		
		var footer = $('div#footer');
		var footerControls = headerControls.clone(true);
		footerControls.css({
				'font-family':'arial', 'font-size':'20px',
				'position':'absolute', 'width': '100%', 'padding':'3px 0px 0px 0px',
				'top':footer.offset().top, 'height': ($('#content').outerHeight()-footer.outerHeight()),
				'background': 'black' 
			});
	
		slide.append(headerControls);
		slide.append(footerControls);
	}
	
	function getNumberedTitle(number,text,x,y)
	{
		var title = $('<div></div>');
		var digit = $('<div></div>');
		digit.append(number);
		digit.css({
			background:'#ffd200','-moz-border-radius': '50px', 'border-radius': '50px', '-webkit-border-radius': '50px',
			width:'45px',height:'45px','text-align':'center',float:'left','margin-right': '10px'});
			
		title.append(digit);
		title.append('  '+text);
		title.css({
			position:'absolute',left: x, top: y, color: 'white', 
			'font-size': '40px', 'line-height':'110%','letter-spacing':'-1px'});
		
		return title;
	}

	function getStartSlide(slide)
	{
		var dialog = $('<div></div>');
		var dialogWidth = 320;
		var dialogHeight = 250;
		var shadow = '5px 5px 10px -2px rgba(0,0,0,0.15)';
		dialog.css({
				position:'absolute',left:'50%',top:'50%','margin-left':('-'+(dialogWidth/2)+'px'), 'margin-top':('-'+(dialogHeight/2-15)+'px'),
				width:dialogWidth, height:dialogHeight,
				background:'white',opacity:'1',
				border:'1px solid #aaa',
				'text-align': 'center',
				'-moz-border-radius': '12px',
				'border-radius': '12px',
				'-webkit-border-radius': '12px',
				'-moz-box-shadow': shadow,
				'box-shadow': shadow
			});
		
		var closeX = $('<span><img src="../img/close.png" /></span>');
		closeX.css({
				float: 'right',
				cursor: 'pointer',
				'margin-right': '-8px',
				'margin-top': '-8px',
			});
			
		var welcomeText = $('<div>Welcome to WiseStamp!<br/>Let\'s take a quick tour!</div>');
		welcomeText.css({color: '#333', 'margin-top': '10px', 'font-size': '18px', 'line-height':'160%'});
		 			
		var startButton = $('<div id="startButton"></div>');
		var startButtonWidth = 270;
		var startButtonHeight = 60;
		startButton.css({
				width: startButtonWidth, height: startButtonHeight, cursor:'pointer', margin:'20px auto 0 auto',
			});
			
		var startText = $('<div>Start &#x25ba;</div>');
		startText.css({
				cursor:'pointer', 'margin-top': '0px',
				'text-align': 'center', 'font-size': '60px', 'font-weight': 'bold', color: 'white'
			});

		var noThanksContainer = $('<div></div>');
		noThanksContainer.css({
				'text-align': 'center', 
				width: '100%', top: '400px',
				position:'absolute' 
			});
			
		var noThanksText = $('<span>No thanks</span>');
		noThanksText.css({
				color: '#333', 'font-size': '18px', 'line-height':'110%', cursor:'pointer'
			});
		
		noThanksContainer.append(noThanksText);
		
		closeX.click(function(){$('.slide').remove()});
		noThanksText.click(function(){$('.slide').remove()});
		startButton.click(function(){
				WiseStampFirstTimeTour.mShown = true;
				moveSlides(0,1);
			});
			
		/*startButton.hover(
			function(){$(this).css({border:'1px solid black'});}, function(){$(this).css({border: 'none'})});
		*/
		addShadow(slide,[],'#6e8c93','0.15');
		
		slide.css({'font-family':'arial'});
		dialog.append(closeX);
		dialog.append(welcomeText);
		dialog.append(startButton);
		startButton.append(startText);
		slide.append(dialog);
		slide.append(noThanksContainer);
		
		return slide;
	}
	
	function getPersonalDetailsSlide(slide,slideNumber)
	{
		if (editor == null)
			editor = $('#textarea_tbl');
			
		addShadow(slide,[{xStart:10,yStart:editor.offset().top,xEnd:10+editor.width()+4,yEnd:editor.offset().top+editor.height()}]);
		addNavigationControls(slide,slideNumber);

		var detailsImage = $('<img src="../img/tour/details.png" />');
		detailsImage.css({
				position: 'absolute',
				left: 14, top: editor.offset().top+45
			});
		
		slide.append(detailsImage);
				
		slide.append(getNumberedTitle(slideNumber,'Edit your personal details',15,270));
		return slide;
	}
	
	function getEmailsAppsSlide(slide,slideNumber)
	{
		var startElement = $('div#tabs');
		
		addShadow(slide,[{
			xStart:13,
			yStart:startElement.offset().top+2,
			xEnd:10+startElement.outerWidth()-1,
			yEnd:startElement.offset().top+startElement.outerHeight()-3}]);
			
		addNavigationControls(slide,slideNumber);
		slide.append(getNumberedTitle(slideNumber,'Add your email apps',30,190));
		return slide;
	}
	
	function getRssSlide(slide,slideNumber)
	{
		var startElement = $('div#tabs');
		
		addShadow(slide,[{
			xStart:13,
			yStart:startElement.offset().top+2,
			xEnd:10+startElement.outerWidth()-1,
			yEnd:startElement.offset().top+startElement.outerHeight()-3}]);
			
		addNavigationControls(slide,slideNumber);
		slide.append(getNumberedTitle(slideNumber,'Add your RSS feeds',30,190));
		return slide;
	}
	
	function getSocialProfilesSlide(slide,slideNumber)
	{
		var startElement = $('div#tabs');
		var bottomElement = $('div#tabs-social .add');
		addShadow(slide,[{
			xStart:13,
			yStart:startElement.offset().top+2,
			xEnd:10+startElement.outerWidth()-1,
			yEnd:bottomElement.offset().top+bottomElement.height()+10}]);
	
		var title = (WiseStamp.config.support.apps) ?
						'More tabs: social icons, IM icons, and design' :
						'Add your social profiles';
		
		addNavigationControls(slide,slideNumber);
		slide.append(getNumberedTitle(slideNumber,title,70,130));
		
		return slide;
	}
	
	function getPreviewSlide(slide,slideNumber)
	{
		var button = $('input#preview-button');
		var buttonLeft = button.offset().left;
		var buttonTop = button.offset().top;
		
		var left = 10 + (($('#content').width() - WiseStampEditor.PREVIEW_DLG_WIDTH) / 2);
		addShadow(slide,[
			{xStart:left,yStart:88,xEnd:left+WiseStampEditor.PREVIEW_DLG_WIDTH,yEnd:400},
			{xStart:buttonLeft, yStart:buttonTop, xEnd:buttonLeft+button.outerWidth()+1,yEnd:buttonTop+button.outerHeight()+1}
			]);
		
		var previewImageFile = WiseStamp.config.support.apps ? 'previewExample.png' : 'previewExampleRss.png';
		var previewImage = $('<img src="../img/'+previewImageFile+'" />');
		previewImage.css({
				position: 'absolute',
				left: '28px', top: '90px'
			});
		
		slide.append(previewImage);
		addNavigationControls(slide,slideNumber);
		slide.append(getNumberedTitle(slideNumber,'Click Preview',50,440));
		
		return slide;
	}
	
	function getDoneSlide(slide,slideNumber)
	{
		var doneButton = $('<div></div>');
		var doneButtonWidth = 350;
		var doneButtonHeight = 160;
		var buttonTop = 180;
		var shadow = '5px 5px 10px -2px rgba(0,0,0,0.15)';
		doneButton.css({
				position:'absolute',left:'50%','margin-left':('-'+(doneButtonWidth/2)+'px'),top:buttonTop,
				width:doneButtonWidth, height:doneButtonHeight,cursor:'pointer',
				background:'white',opacity:'1',
				border:'1px solid #aaa',
				'text-align': 'center',
				'-moz-border-radius': '20px',
				'border-radius': '20px',
				'-webkit-border-radius': '20px',
				'-moz-box-shadow': shadow,
				'box-shadow': shadow
			});
			
		//doneButton.hover(
		//	function(){$(this).css({opacity:'0.5'});}, function(){$(this).css({opacity:'0.4'})});
		
		var doneText = $('<div>That\'s it!<br/>Enjoy WiseStamp!</div>');
		doneText.css({
				cursor:'pointer',
				'font-size': '23px', 'line-height':'160%', color: '#666',
				'text-align': 'center', 'margin':'10px auto 0 auto'
			});
		
		var clickhereText = $('<div id=continueButton>Click here to continue.</div>');
		clickhereText.css({
				width: 260, height: 30, margin:'20px auto 0 auto',
			});
		
		doneButton.click(function(){$('.slide').remove()});
		
		addShadow(slide,[]);
		slide.append(doneButton);
		doneButton.append(doneText);
		doneButton.append(clickhereText);
		
		addNavigationControls(slide,slideNumber);
		return slide;
	}
	
	this.show = function()
	{
		var iSlide = 0;
		mSlidesFactory[iSlide++] = getStartSlide;
		mSlidesFactory[iSlide++] = getPersonalDetailsSlide;
		if (WiseStamp.config.support.apps)
			mSlidesFactory[iSlide++] = getEmailsAppsSlide;

		mSlidesFactory[iSlide++] = getSocialProfilesSlide;
		
		if (!WiseStamp.config.support.apps)
			mSlidesFactory[iSlide++] = getRssSlide;
		
		mSlidesFactory[iSlide++] = getPreviewSlide;
		mSlidesFactory[iSlide++] = getDoneSlide;
		
		mSlidesCount = iSlide;
		
		getSlide(0).show();
	}
	
	/////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////
};

WiseStampFirstTimeTour.show();