﻿var WiseStampLocale = new function()
{
	var jsonLocaleData;
	
	function loadLocaleScript(scriptPath, localeVarName) {
		var fileref=document.createElement('script');
		fileref.setAttribute("type","text/javascript");
		fileref.setAttribute("src", scriptPath);
		fileref.onload = function() {
				jsonLocaleEnglishData = LOCALIZED_STRINGS_EN;
				jsonLocaleData = LOCALIZED_STRINGS_ES; //TOFIX   localeVarName;
		};
		document.getElementsByTagName("head")[0].appendChild(fileref);
		return;
	}
	
	this.init = function()
	{
		WiseStampUtils.log("[WiseStampLocale::init] platform - " + WiseStamp.sys.platform);

		switch(WiseStamp.sys.platform) {
			case 'mozilla':
				var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch2);
				//var features;
				try {
					var locale = prefs.getCharPref("general.useragent.locale");
					WiseStampUtils.log("[WiseStampLocale::init] locale - " + locale);
					var lang = locale.substr(0,2);
				} catch(e) {
					jsonLocaleData = LOCALIZED_STRINGS_EN;
					if (WiseStampUser.isTester())
						alert("Failed to extract locale string from Firefox - will 'fall back' to the default English version.");
				}				
				switch (lang) {
					case 'es':
						loadLocaleScript ("chrome://wisestamp/content/locale/messages-es.js", "LOCALIZED_STRINGS_ES");
						break;
					default:
						jsonLocaleData = LOCALIZED_STRINGS_EN;
						break;
				}
				break;
			case chrome:
				break;
			default:
				jsonLocaleData = LOCALIZED_STRINGS_EN;
				break;
		}			
	}

	this.getLocalizedMessage = function(msg)
	{	
		switch (WiseStamp.sys.platform)
		{
		////THE MOZILLA CASE SUPPORTS UP TO ONE PARAMETER AT THE MOMNT
//		case 'mozilla':
//			var stringsBundle = window.parent.document.getElementById("WSstring-bundle");
//			var msgTxt;
//			if (arguments.length == 1) {
//				msgTxt = stringsBundle.getString(msg);  ////.getString(msg);
//			} else {
				//alert("arguments.length " + arguments.length + " Msg - " + msg);
//				msgTxt = stringsBundle.getFormattedString(msg, [arguments[1]]);
				//	msgTxt = stringsBundle.getFormattedString.apply(this, arguments);
				//	msgTxt = stringsBundle.getFormattedString.apply(this, arguments);
				//	msgTxt = stringsBundle.getFormattedString.call(this, arguments);
//			}
//			return msgTxt;
		case 'chrome':
			var msgTxt = chrome.i18n.getMessage.apply(null, arguments);
			return msgTxt;
		default: 
			if (jsonLocaleData[msg]) {
				var msgTxt = jsonLocaleData[msg]['message'];
			} else if (jsonLocaleEnglishData[msg]) {
				var msgTxt = jsonLocaleEnglishData[msg]['message'];
				if (WiseStampUser.isTester())
					alert("Failed to extract the string '" + msg + "' from the localized version - will 'fall back' to the default English version.");
				} else {
					var msgTxt = "";
					if (WiseStampUser.isTester())
					alert("Failed to extract the string '" + msg + "' from the localized version and no default English 'fall back' was detected - The string will default to an empty string.");
				}
			//match all parameters hiding between two $ signs.
			var msgPlaceholders = msgTxt.match(/\$.*?\$/g);
			//itirate over all the matched params (if a match exists).
			if (msgPlaceholders != null) {
				for (i=0; i < msgPlaceholders.length; i++) {
					//get a parameter name.
					paramName = msgPlaceholders[i].toLowerCase();
					//chop off the $ signs.
					paramName = paramName.slice(1, -1);
					//get the value from the json.
					param = jsonLocaleData[msg]['placeholders'][paramName]['content'];
					//if the vale begins with a & sign the parameter should be replaced with an argument this function got.
					if (param.charAt(0) == "$") {
						param = param.slice(1);
						param = parseInt(param);
						param = arguments[param];
					}
					placeholder = msgPlaceholders[i];
					msgTxt = msgTxt.replace( placeholder, param);
				}
			}		
			return msgTxt;
		}
	}
				
};

WiseStampLocale.init();

//WiseStamp._ = WiseStampLocale.getLocalizedMessage;