var WiseStampObserver = new function() 
{
	var WISESTAMP_ADDON_ID = "wisestamp@wisestamp.com";
	
	
	this.init = function()
	{
		try {
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.addAddonListener(this);
		}
		catch (e) {}
		
		this.register();
	}
	
	// FF4 AddonListener interface
	this.onUninstalling = function(addon, needsRestart)
	{
		if (addon.id != WISESTAMP_ADDON_ID)
			return;
		
		WiseStampExtension.onUninstall();
	}
	
	/* doesn't seem to work [Sasha]
	this.onDisabled = function(addon)
	{
		if (addon.id != WISESTAMP_ADDON_ID)
			return;
		
		WiseStampExtension.onDisable();
	}
	*/
	
	this.onDisabling = function(addon, needsRestart)
	{
		if (addon.id != WISESTAMP_ADDON_ID)
			return;
		
		WiseStampExtension.onDisable();
	}
	
	// wasn't able to catch this, but let's leave it here just in case [Sasha]
	this.onEnabled = function(addon)
	{
		if (addon.id != WISESTAMP_ADDON_ID)
			return;
		
		WiseStampExtension.onEnable();
	}
	
	/* doesn't seem to work [Sasha]
	this.onEnabling = function(addon, needsRestart)
	{
		if (addon.id != WISESTAMP_ADDON_ID)
			return;
		
		WiseStampExtension.onEnable();
	}
	*/
	//
	
	this.register = function() 
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		if (observerService == null)
			return;
		
		observerService.addObserver(this, "em-action-requested", false);
	}
	
	this.unregister = function() 
	{
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.removeObserver(this, "em-action-requested");
	}
	
	this.observe = function(subject, topic, data) 
	{	
		if (topic == "em-action-requested")
		{
			subject.QueryInterface(Components.interfaces.nsIUpdateItem); 
			if (subject.id != WISESTAMP_ADDON_ID)
				return;
				
			switch(data)
			{
			case "item-installed":
				break;
			
			/*case "item-upgraded":
				var currentVersion = WiseStampUtils.getVersion();
				var updateURL = "http://www.wisestamp.com/version-history/firefox/" + currentVersion;
				WisestampGetAppObject().openSite(updateURL);
				break;*/
				
			case "item-uninstalled":
				WiseStampExtension.onUninstall();
				break;
				
			case "item-disabled":
				WiseStampExtension.onDisable();
				break;
				
			case "item-enabled":
				WiseStampExtension.onEnable();
				break;				
			}
		}
	}
}

WiseStampObserver.init();